﻿using Newtonsoft.Json;
using Syncfusion.EJ.Export;
using Syncfusion.JavaScript.Models;
using Syncfusion.XlsIO;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Reflection;
using System.Web;
using System.Web.Http;
using Syncfusion.Linq;
using System.Web.Script.Serialization;
using WebApplication21.Models;

namespace WebApplication21
{
    public class EmployeesController : ApiController
    {
        public IEnumerable currentData;
        // GET api/<controller>
        NorthWndDataContext db = new NorthWndDataContext();
        public object Get()
        {
            var data = db.EmployeeTerritories;
            return data;
        }
        public void ExcelExport()
        {
            IEnumerable DataSource;
            ExcelExport exp = new ExcelExport();
            string gridModel = System.Web.HttpContext.Current.Request.Params["GridModel"];
            GridProperties obj = ConvertGridObject(gridModel);
            if (currentData.AsQueryable().Count() > 0)
                DataSource = currentData;
            else
                DataSource = db.Orders.ToList();
            exp.Export(obj, DataSource, "Export.xlsx", ExcelVersion.Excel2010, false, false, "flat-saffron");
        }

        private GridProperties ConvertGridObject(string gridProperty)
        {
            JavaScriptSerializer serializer = new JavaScriptSerializer();
            IEnumerable div = (IEnumerable)serializer.Deserialize(gridProperty, typeof(IEnumerable));
            GridProperties gridProp = new GridProperties();
            foreach (KeyValuePair<string, object> ds in div)
            {
                if (ds.Key == "currentData")
                {
                    string str = Convert.ToString(ds.Value);
                    currentData = JsonConvert.DeserializeObject<IEnumerable<Order>>(str);
                    continue;
                }
                var property = gridProp.GetType().GetProperty(ds.Key, BindingFlags.Instance | BindingFlags.Public | BindingFlags.IgnoreCase);
                if (property != null)
                {
                    Type type = property.PropertyType;
                    string serialize = serializer.Serialize(ds.Value);
                    object value = serializer.Deserialize(serialize, type);
                    property.SetValue(gridProp, value, null);
                }
            }
            return gridProp;
        }
        // GET api/<controller>/5
        public string Get(int id)
        {
            return "value";
        }

        // POST api/<controller>
        public void Post([FromBody]string value)
        {
        }

        // PUT api/<controller>/5
        public void Put(int id, [FromBody]string value)
        {
        }

        // DELETE api/<controller>/5
        public void Delete(int id)
        {
        }
    }
}